diff --git a/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
similarity index 98%
rename from src/main/java/net/minecraft/client/gui/hud/HudIngame.java
rename to game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 77c914c5e..0aeba6b6f 100644
--- a/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -367,8 +367,8 @@ public class HudIngame extends Gui
                 {
                     debugOffset += space;
 
-                    Block block = Block.blocksList[mc.currentWorld.getBlockId(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z)];
-                    if (block.id > 0 && block.id < Block.blocksList.length)
+                    Block block = Blocks.blocksList[mc.currentWorld.getBlockId(mc.objectMouseOver.x, mc.objectMouseOver.y, mc.objectMouseOver.z)];
+                    if (block.id > 0 && block.id < Blocks.blocksList.length)
                     {
                         drawDebugScreenLineRight("Looking at:");
 
@@ -383,9 +383,10 @@ public class HudIngame extends Gui
                             name = "<ERROR>";
                         }
 
-                        String id = block.getLanguageKey(meta) + " [" + block.id + ":" + meta + "]";
+                        String id = block.namespaceID + " [" + block.id + ":" + meta + "]";
 
                         drawDebugScreenLineRight(name);
+                        drawDebugScreenLineRight(block.getLanguageKey(meta));
                         drawDebugScreenLineRight(id);
 
                         if (compass)
@@ -944,7 +945,7 @@ public class HudIngame extends Gui
         GL11.glDepthMask(false);
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, intensity);
-        IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Block.getBlock(mc.thePlayer.portalID)).getBlockTextureFromSideAndMetadata(Side.NORTH, mc.thePlayer.portalColor.blockMeta << 4 | BlockPortal.MASK_COLOR_SET);
+        IconCoordinate portal = BlockModelDispatcher.getInstance().getDispatch(Blocks.getBlock(mc.thePlayer.portalID)).getBlockTextureFromSideAndMetadata(Side.NORTH, mc.thePlayer.portalColor.blockMeta << 4 | BlockPortal.MASK_COLOR_SET);
         portal.parentAtlas.bind();
         float f1 = (float) portal.getIconUMin();
         float f2 = (float) portal.getIconVMin();
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
similarity index 98%
rename from src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
rename to game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
index 0f529e099..fd8b9830f 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/ScreenModelViewer.java
@@ -23,6 +23,7 @@ import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.texture.Texture;
 import net.minecraft.client.util.helper.Textures;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
@@ -404,9 +405,9 @@ public class ScreenModelViewer extends ScreenPhotoMode implements ListenerTextFi
         mc.displayScreen(new OptionsScreen(null, OptionsPages.DEBUG));
     }
     public static int cycleBlockId(int id, int idOff){
-        int id2 = (id + Block.blocksList.length + idOff) % Block.blocksList.length;
-        while (Block.blocksList[id2] == null){
-            id2 = (id2 + (int) Math.signum(idOff) + Block.blocksList.length) % Block.blocksList.length;
+        int id2 = (id + Blocks.blocksList.length + idOff) % Blocks.blocksList.length;
+        while (Blocks.blocksList[id2] == null){
+            id2 = (id2 + (int) Math.signum(idOff) + Blocks.blocksList.length) % Blocks.blocksList.length;
         }
         return id2;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
similarity index 90%
rename from src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
rename to game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
index 1a3b3dd61..60084e433 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/ViewerCategoryBlock.java
@@ -29,7 +29,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         createEntries();
     }
     public void createEntries(){
-        for (Block block : Block.blocksList){
+        for (Block block : Blocks.blocksList){
             if (block == null) continue;
             entryHashMap.put(block, new BlockEntryBasic(block));
         }
@@ -46,7 +46,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
 
     @Override
     public String getCurrentDisplayInfo(I18n translator) {
-        Block displayBlock = Block.getBlock(DisplayChunk.displayBlockId);
+        Block displayBlock = Blocks.getBlock(DisplayChunk.displayBlockId);
         String name = "None";
         if (displayBlock != null){
             name = I18n.getInstance().translateNameKey(displayBlock.getKey());
@@ -78,8 +78,8 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
             @Override
             public Integer getElementFromString(String s) {
                 try {
-                    int id = MathHelper.clamp(Integer.parseInt(s), 0, Block.blocksList.length);
-                    if (Block.getBlock(id) != null){
+                    int id = MathHelper.clamp(Integer.parseInt(s), 0, Blocks.blocksList.length);
+                    if (Blocks.getBlock(id) != null){
                         return id;
                     }
                 } catch (Exception ignored){}
@@ -131,7 +131,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         int yPos = blockMetaTextField.yPosition + 21;
         int xPos = modelViewer.width;
 
-        BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+        BlockEntry entry = entryHashMap.get(Blocks.getBlock(DisplayChunk.displayBlockId));
 
         if (entry != null){
             List<ButtonElement> list = entry.getEntryButtons(mc, modelViewer, mc.currentWorld, DisplayChunk.displayBlockMeta);
@@ -162,7 +162,7 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
 
     @Override
     public void onTick() {
-        BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+        BlockEntry entry = entryHashMap.get(Blocks.getBlock(DisplayChunk.displayBlockId));
         if (entry != null){
             entry.onTick(mc.currentWorld, DisplayChunk.displayBlockMeta);
         }
@@ -170,8 +170,8 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         mc.currentWorld.loadedEntityList.removeIf(entity -> entity instanceof EntityItem);
     }
     public void setDisplayBlock(int id, int meta){
-        Block displayBlock = Block.blocksList[DisplayChunk.displayBlockId];
-        BlockEntry entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+        Block displayBlock = Blocks.blocksList[DisplayChunk.displayBlockId];
+        BlockEntry entry = entryHashMap.get(Blocks.getBlock(DisplayChunk.displayBlockId));
         int _id = DisplayChunk.displayBlockId;
         int _meta = DisplayChunk.displayBlockMeta;
 
@@ -186,9 +186,9 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
         DisplayChunk.displayBlockPosZ = (int) mc.thePlayer.z;
         DisplayChunk.displayBlockId = id;
         DisplayChunk.displayBlockMeta = meta;
-        displayBlock = Block.blocksList[id];
+        displayBlock = Blocks.blocksList[id];
         if (displayBlock != null && _id != id){
-            entry = entryHashMap.get(Block.getBlock(DisplayChunk.displayBlockId));
+            entry = entryHashMap.get(Blocks.getBlock(DisplayChunk.displayBlockId));
             displayBlock.onBlockPlacedByWorld(mc.currentWorld, (int) mc.thePlayer.x, (int) mc.thePlayer.y, (int) mc.thePlayer.z);
             if (entry != null) entry.onOpen(mc.currentWorld, DisplayChunk.displayBlockMeta);
         }
@@ -196,6 +196,6 @@ public class ViewerCategoryBlock extends ModelViewerCategory {
             modelViewer.init();
         }
         mc.particleEngine.setWorld(mc.currentWorld);
-        mc.renderGlobal.loadRenderers();
+        mc.currentWorld.markBlockDirty(DisplayChunk.displayBlockPosX, DisplayChunk.displayBlockPosY, DisplayChunk.displayBlockPosZ);
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
similarity index 96%
rename from src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
rename to game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
index b9e61263f..90c02ceb8 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/block/BlockEntryJar.java
@@ -36,8 +36,8 @@ public class BlockEntryJar extends BlockEntry{
             @Override
             public Integer getElementFromString(String s) {
                 try {
-                    int id = MathHelper.clamp(Integer.parseInt(s), 0, Block.blocksList.length);
-                    if (Block.getBlock(id) != null){
+                    int id = MathHelper.clamp(Integer.parseInt(s), 0, Blocks.blocksList.length);
+                    if (Blocks.getBlock(id) != null){
                         return id;
                     }
                 } catch (Exception ignored){}
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
similarity index 95%
rename from src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
rename to game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
index a3882b080..435785984 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryFallingBlock.java
@@ -7,6 +7,7 @@ import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
 
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.entity.EntityFallingBlock;
 import net.minecraft.core.world.World;
 
@@ -31,7 +32,7 @@ public class EntityEntryFallingBlock extends EntityEntry<EntityFallingBlock>{
             public Integer getElementFromString(String s) {
                 try {
                     int id = Integer.parseInt(s);
-                    if (Block.blocksList[id] != null) return id;
+                    if (Blocks.blocksList[id] != null) return id;
                 } catch (Exception ignored){}
                 return sand.carriedBlock.blockId;
             }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
similarity index 97%
rename from src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
rename to game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
index 93b81b16f..6ba13b55c 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryBlock.java
@@ -8,6 +8,7 @@ import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.ListSelectorButtonElement;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
@@ -93,7 +94,7 @@ public class ParticleEntryBlock extends ParticleEntryGeneric {
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.particleEngine.add(new ParticleBlockBreaking(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), side, meta));
+        mc.particleEngine.add(new ParticleBlockBreaking(world, x, y, z, motionX,motionY,motionZ, Blocks.getBlock(blockId), side, meta));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
similarity index 91%
rename from src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
rename to game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
index d982b4cde..44390d55f 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ParticleEntryItem.java
@@ -6,6 +6,7 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.elements.TextCycleElement;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.Item;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.util.helper.MathHelper;
@@ -68,13 +69,13 @@ public class ParticleEntryItem extends ParticleEntry{
 
     }
     private int cycleItemId(int itemId, int offset){
-        int numItems = Item.itemsList.length - Block.blocksList.length;
+        int numItems = Item.itemsList.length - Blocks.blocksList.length;
 
         int _itemId = MathHelper.clamp(itemId - numItems, 0, numItems);
         int id = (_itemId + numItems + offset) % numItems;
-        while (Item.itemsList[id + Block.blocksList.length] == null){
+        while (Item.itemsList[id + Blocks.blocksList.length] == null){
             id = (id + (int) Math.signum(offset) + numItems) % numItems;
         }
-        return id + Block.blocksList.length;
+        return id + Blocks.blocksList.length;
     }
 }
